function Create(self)
	self.DoubleClickTimer = Timer();
	self.Clicked = true
	self.GliderEnabled = false
	self.GliderFrame = 0
	self.GliderFrameTarget = 0
	self.GliderFrameDelta = 0
	self.GliderDamage = 0
	
	--mails self.attachable handler
	local i = 1;
	while i < MovableMan:GetMOIDCount() do
		if MovableMan:GetMOFromID(i).RootID == self.ID and i ~= self.ID then
			self.att = MovableMan:GetMOFromID(i)
			if string.find(self.att.PresetName, "Glider") then
				self.Glider = ToAttachable(self.att)
			end
		end
		i = i + 1
	end
	self.Head.Frame = math.random(0,2)
	self.ViewDistance = 0
end

function Update(self)
  local ViewTarget = 0
  if self.Sharpness > 1 then
    self.GliderDamage = self.GliderDamage + self.Sharpness - 1
    self.Sharpness = 1
    if self.Glider ~= nil and self.Glider.ID ~= nil and self.Glider:IsAttached() then
      self.Glider.Sharpness = 1
    end
  end
  local ctrl = self:GetController()
  if ctrl:IsState(Controller.BODY_CROUCH) then
    if self.Clicked then
      if self.DoubleClickTimer:IsPastSimMS(250) then
        self.DoubleClickTimer:Reset();
      else
        self.GliderEnabled = not self.GliderEnabled
      end
    end
    self.Clicked = false
  else
    self.Clicked = true
  end
  --Aerodynamic stuff
  if self.Glider ~= nil and self.Glider.ID ~= nil and self.Glider:IsAttached() then
    if self.GliderEnabled then
      local strikePoint = self.Glider.Pos + self.Glider:RotateOffset(Vector(0 , 45));
      Strength = SceneMan:CastStrengthRay(self.Glider.Pos, self.Glider:RotateOffset(Vector(0 , 45)) , 10, strikePoint, 0 , 0 , SceneMan.SceneWrapsX);
      local pos = SceneMan:GetLastRayHitPos()
      local dist = SceneMan:ShortestDistance(self.Glider.Pos,pos,SceneMan.SceneWrapsX).Magnitude
      local strikePoint = self.Glider.Pos + self.Glider:RotateOffset(Vector(0 , -36));
      Strength = SceneMan:CastStrengthRay(self.Glider.Pos, self.Glider:RotateOffset(Vector(0 , -36)) , 10, strikePoint, 0 , 0 , SceneMan.SceneWrapsX);
      local pos2 = SceneMan:GetLastRayHitPos()
      local dist2 = SceneMan:ShortestDistance(self.Glider.Pos,pos2,SceneMan.SceneWrapsX).Magnitude
      self.GliderFrameTarget = math.max(0 , math.min(dist/5 - 1 , dist2/4 - 1))
      if dist < 40 then
        self:AddAbsForce( self:RotateOffset(Vector(0 , -(19-math.min(9 , self.Frame))*37.5)),self.Pos );
        local PointDist = SceneMan:ShortestDistance(self.Pos,pos,SceneMan.SceneWrapsX)
        local PointRotationVector = Vector(-1,0):RadRotate(PointDist.AbsRadAngle)
        local PointAngularVel = PointRotationVector*PointDist.Magnitude * 10
        local PointVel = PointAngularVel*self.AngularVel + self.Vel
        self:AddAbsForce( PointVel:SetMagnitude(-PointVel.Magnitude * self.Mass*0.01) ,self.Pos )
        local PointAngularSpeed = (PointRotationVector * (PointAngularVel.X*PointRotationVector.X + PointAngularVel.Y*PointRotationVector.Y)).Magnitude
        if (PointAngularVel.X*PointRotationVector.Y - PointAngularVel.Normalized.Y*PointRotationVector.X) < 0 then
          PointAngularSpeed = PointAngularSpeed * -1;
        end
        if self.HFlipped then
          self.AngularVel = self.AngularVel + (19-math.min(9 , self.Frame))*0.75/self.Mass + PointAngularSpeed/2000
        else
          self.AngularVel = self.AngularVel - (19-math.min(9 , self.Frame))*0.75/self.Mass + PointAngularSpeed/2000
        end
      end
      if dist2 < 30 then
        self:AddAbsForce( self:RotateOffset(Vector(0 , (19-math.min(9 , self.Frame))*37.5)),self.Pos );
        local PointDist = SceneMan:ShortestDistance(self.Pos,pos2,SceneMan.SceneWrapsX)
        local PointRotationVector = Vector(-1,0):RadRotate(PointDist.AbsRadAngle)
        local PointAngularVel = PointRotationVector*PointDist.Magnitude * 10
        local PointVel = PointAngularVel*self.AngularVel + self.Vel
        self:AddAbsForce( PointVel:SetMagnitude(-PointVel.Magnitude * self.Mass*0.01) ,self.Pos )
        local PointAngularSpeed = (PointRotationVector * (PointAngularVel.X*PointRotationVector.X + PointAngularVel.Y*PointRotationVector.Y)).Magnitude
        if (PointAngularVel.X*PointRotationVector.Y - PointAngularVel.Normalized.Y*PointRotationVector.X) < 0 then
          PointAngularSpeed = PointAngularSpeed * -1;
        end
        if self.HFlipped then
          self.AngularVel = self.AngularVel - (19-math.min(9 , self.Frame))*0.75/self.Mass + PointAngularSpeed/2000
        else
          self.AngularVel = self.AngularVel + (19-math.min(9 , self.Frame))*0.75/self.Mass + PointAngularSpeed/2000
        end
      end
      if math.min(8 ,self.GliderFrameTarget) == 8 then
        self.GliderFrameTarget = 12
      end
      if self.MovementState ~= 8 then
        self.MovementState = 8
      else
        self.MovementState = 0
      end
      self.JumpState = 3
      local direction = self.Vel.AbsRadAngle
      
      local AirRessistanceForce = 0.003 * self.AngularVel^2 * self.GliderFrame/self.Mass*(60 - self.GliderDamage)/60
      if self.AngularVel > 0 then
        if self.AngularVel - AirRessistanceForce > 0 then
          self.AngularVel = self.AngularVel - AirRessistanceForce
        else
          self.AngularVel = 0
        end
      else
        if self.AngularVel + AirRessistanceForce < 0 then
          self.AngularVel = self.AngularVel + AirRessistanceForce
        else
          self.AngularVel = 0
        end
      end
      local RotAngleVector = Vector(math.cos(self.RotAngle * -1 + math.pi*0.5) , math.sin(self.RotAngle * -1 + math.pi*0.5))
      local AirShadow = (RotAngleVector * (self.Vel.Normalized.X*RotAngleVector.X + self.Vel.Normalized.Y*RotAngleVector.Y)).Magnitude
      local RotAngleVectorPer = RotAngleVector.Perpendicular
      local DirectionalSpeed = (RotAngleVectorPer * (self.Vel.X*RotAngleVectorPer.X + self.Vel.Y*RotAngleVectorPer.Y)).Magnitude
      local negatore = 1
      if (self.Vel.Normalized.X*RotAngleVector.Y - self.Vel.Normalized.Y*RotAngleVector.X) < 0 then
        negatore = -1;
      end

      local DirectionalSpeedX = (RotAngleVector * (self.Vel.X*RotAngleVector.X + self.Vel.Y*RotAngleVector.Y)).Magnitude
    
      local modifier = 0
      if ctrl:IsState(Controller.MOVE_RIGHT) then
        modifier = 90/(100+math.abs(DirectionalSpeedX)^0.5) + math.random()*(self.GliderDamage - self.GliderDamage*0.5)/25
      end
      if ctrl:IsState(Controller.MOVE_LEFT)then
        modifier = modifier - 90/(100+math.abs(DirectionalSpeedX)^0.5) - math.random()*(self.GliderDamage - self.GliderDamage*0.5)/25
      end
      if ctrl:IsState(Controller.BODY_CROUCH) then
        modifier = modifier * 1.5*(100+math.abs(DirectionalSpeedX)^0.5)/100
      end
      modifier = modifier + (self.GliderDamage - self.GliderDamage*0.5)/50
      local power = 0.03*self.Vel.Magnitude^2*(60 - self.GliderDamage)/60
      local i = math.floor(power)
      while i > 0 do
        self.AngularVel = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 + modifier - direction)*2) * self.GliderFrame/self.Mass
        i = i - 1
      end
      self.AngularVel = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 + modifier - direction)*2)*(power-math.floor(power)) * self.GliderFrame/self.Mass
          
      local AirRessistanceForce = AirShadow * -5 * DirectionalSpeed^2 * self.GliderFrame
  --      self.Vel = self.Vel - RotAngleVectorPer*AirRessistanceForce * negatore
      self:AddAbsForce( RotAngleVectorPer*AirRessistanceForce * negatore*(60 - self.GliderDamage)/60,self.Pos );
      self.ViewDistance = self.ViewDistance * (math.abs(math.cos(self.RotAngle + math.pi*0.5 - direction)*0.8) + 0.2)
      if (self.Vel.Normalized.X*RotAngleVectorPer.Y - self.Vel.Normalized.Y*RotAngleVectorPer.X) < 0 then
        DirectionalSpeedX = DirectionalSpeedX * -1;
      end
      if DirectionalSpeedX*10 < FrameMan.PlayerScreenWidth*0.8 and DirectionalSpeedX*10 > -FrameMan.PlayerScreenWidth*0.8 then
        ViewTarget = DirectionalSpeedX*10
      elseif DirectionalSpeedX*10 > FrameMan.PlayerScreenWidth*0.8 then
        ViewTarget = FrameMan.PlayerScreenWidth*0.8
      elseif DirectionalSpeedX*10 < -FrameMan.PlayerScreenWidth*0.8 then
        ViewTarget = -FrameMan.PlayerScreenWidth*0.8
      end
      ViewTarget = ViewTarget + DirectionalSpeedX*0.1
    else
      self.GliderFrameTarget = 0
    end
    local delta = 0
    if self.GliderFrame <= self.GliderFrameTarget-1 then
      self.GliderFrame = self.GliderFrame + 1
      if self.GliderFrame < 9 then
        delta = -(19-math.min(9 , self.Frame))/15
        self.AngularVel = self.AngularVel * 0.9302^(50/self.Mass)
      end
    elseif self.GliderFrame >= self.GliderFrameTarget+1 then
      self.GliderFrame = self.GliderFrame - 1
      if self.GliderFrame < 9 then
        delta = (19-math.min(9 , self.Frame))/15
        self.AngularVel = self.AngularVel * 1.075^(50/self.Mass)
      end
    else
      self.GliderFrame = self.GliderFrameTarget
    end
    if delta - self.GliderFrameDelta ~= 0 then
      if self.HFlipped then
        self.AngularVel = self.AngularVel - 200/self.Mass * (delta - self.GliderFrameDelta)
      else
        self.AngularVel = self.AngularVel + 200/self.Mass * (delta - self.GliderFrameDelta)
      end
      
      self:AddAbsForce( self:RotateOffset(Vector(0 , 10000 * (delta - self.GliderFrameDelta))),self.Pos );
    end
    if self.GliderFrameDelta < delta - 0.35 then
      self.GliderFrameDelta = self.GliderFrameDelta + 0.35
    elseif self.GliderFrameDelta > delta + 0.35 then
      self.GliderFrameDelta = self.GliderFrameDelta - 0.35
    else
      self.GliderFrameDelta = delta
    end
    self.Glider.Frame = math.floor(self.GliderFrame)
    if self.GliderFrame == 13 and AirRessistanceForce ~= nil and (self.Glider.Frame == 9 or self.Glider.Frame == 11 or self.Glider.Frame == 12 or self.Glider.Frame == 13) then
      local frameforce = math.abs(DirectionalSpeedX) - math.abs(AirRessistanceForce*0.05)
      if frameforce < -40 then
        self.Glider.Frame = 13
      elseif  frameforce < -20 then
        self.Glider.Frame = 11
      elseif  frameforce < 20 then
        self.Glider.Frame = 12
      else
        self.Glider.Frame = 9
      end
    end
  else
    self.GliderEnabled = false
  end
  local direction = self.Vel.AbsRadAngle
  
  local AirRessistanceForce = 0.001 * self.AngularVel^2/self.Mass
  if self.AngularVel > 0 then
    if self.AngularVel - AirRessistanceForce > 0 then
      self.AngularVel = self.AngularVel - AirRessistanceForce
    else
      self.AngularVel = 0
    end
  else
    if self.AngularVel + AirRessistanceForce < 0 then
      self.AngularVel = self.AngularVel + AirRessistanceForce
    else
      self.AngularVel = 0
    end
  end
  local RotAngleVector = Vector(math.cos(self.RotAngle * -1 + math.pi*0.5) , math.sin(self.RotAngle * -1 + math.pi*0.5))
  local AirShadow = (RotAngleVector * (self.Vel.Normalized.X*RotAngleVector.X + self.Vel.Normalized.Y*RotAngleVector.Y)).Magnitude
  local RotAngleVectorPer = RotAngleVector.Perpendicular
  local DirectionalSpeed = (RotAngleVectorPer * (self.Vel.X*RotAngleVectorPer.X + self.Vel.Y*RotAngleVectorPer.Y)).Magnitude
  local negatore = 1
  if (self.Vel.Normalized.X*RotAngleVector.Y - self.Vel.Normalized.Y*RotAngleVector.X) < 0 then
    negatore = -1;
  end

  local DirectionalSpeedX = (RotAngleVector * (self.Vel.X*RotAngleVector.X + self.Vel.Y*RotAngleVector.Y)).Magnitude

  local power = 0.005*self.Vel.Magnitude^2
  local i = math.floor(power)
  local i = math.floor(power)
  while i > 0 do
    self.AngularVel = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 - direction)*2)/self.Mass
    i = i - 1
  end
  self.AngularVel = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 - direction)*2)*(power-math.floor(power))/self.Mass
      
  local AirRessistanceForce = AirShadow * -5 * DirectionalSpeed^2 * self.Frame
--      self.Vel = self.Vel - RotAngleVectorPer*AirRessistanceForce * negatore
  self:AddAbsForce( RotAngleVectorPer*AirRessistanceForce * negatore,self.Pos );

  local AirRessistanceForce = -0.2 * self.Vel.Magnitude^2
  self:AddAbsForce( self.Vel.Normalized*AirRessistanceForce,self.Pos );
  self.ViewDistance = (self.ViewDistance + ViewTarget*0.1)/1.1
  if self.GliderEnabled then
    self.ViewPoint = self.Pos - self:RotateOffset(Vector(0 , self.ViewDistance));
  end
end
